#property indicator_separate_window
#property indicator_levelcolor Black
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 Crimson

#include <stdlib.mqh>

extern int FastEMA = 3;
extern int SlowEMA = 5;
extern int SignalEMA = 3;
extern color OscColor = RoyalBlue;
extern color SigColor = Crimson;
double gd_96;
double gd_104;
int gi_112;
int gi_116;
int gi_120;
double gd_124;
double gd_132;
double gd_140;
double gd_148;
double g_ibuf_156[];
double g_ibuf_160[];
double gda_164[25000];
double gda_168[25000];
double gda_172[25000];

int init() {
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexBuffer(0, g_ibuf_156);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 1, C'0x03,0x00,0x00');
   SetIndexBuffer(1, g_ibuf_160);
   ArraySetAsSeries(gda_164, TRUE);
   ArraySetAsSeries(gda_168, TRUE);
   ArraySetAsSeries(gda_172, TRUE);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_4 = Bars - li_0;
   for (gi_112 = li_4; gi_112 >= 0; gi_112--) {
      gd_96 = (High[gi_112] + Low[gi_112] + Close[gi_112]) / 3.0;
      if (gd_96 > gd_104) gi_116 = 1;
      else gi_116 = -1;
      gd_140 = High[gi_112] - Low[gi_112];
      if (gi_116 == gi_120) gd_124 = gd_132 + gd_140;
      else gd_124 = gd_148 + gd_140;
      if (!CompareDoubles(gd_124, 0.0)) gda_164[gi_112] = 100.0 * (Volume[gi_112] * MathAbs(2.0 * (gd_140 / gd_124) - 1.0) * gi_116);
      gd_104 = gd_96;
      gi_120 = gi_116;
      gd_132 = gd_124;
      gd_148 = gd_140;
   }
   for (gi_112 = 0; gi_112 <= li_4; gi_112++) {
      gda_168[gi_112] = iMAOnArray(gda_164, 0, FastEMA, 0, MODE_EMA, gi_112);
      gda_172[gi_112] = iMAOnArray(gda_164, 0, SlowEMA, 0, MODE_EMA, gi_112);
      g_ibuf_156[gi_112] = gda_168[gi_112] - gda_172[gi_112];
   }
   for (gi_112 = 0; gi_112 <= li_4; gi_112++) g_ibuf_160[gi_112] = iMAOnArray(g_ibuf_156, 0, SignalEMA, 0, MODE_EMA, gi_112);
   return (0);
}